//
//  MyScene.m
//  SpriteKitDemo2
//

#import "MyScene.h"
#import "PhysicsScene.h"

@implementation MyScene{
	
	BOOL		_touch;
}

-(id)initWithSize:(CGSize)size {    
    if (self = [super initWithSize:size]) {
        /* Setup your scene here */
        
        self.backgroundColor = [SKColor colorWithRed:0.15 green:0.15 blue:0.3 alpha:1.0];
        
        SKLabelNode *myLabel1 = [SKLabelNode labelNodeWithFontNamed:@"Chalkduster"];
        myLabel1.text = @"Let's begin to use sprite kit!";
        myLabel1.fontSize = 18;
		myLabel1.name = @"label";
        myLabel1.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame)+100);
        [self addChild:myLabel1];
		
        SKLabelNode *myLabel2 = [SKLabelNode labelNodeWithFontNamed:@"Chalkduster"];
        myLabel2.text = @"Please, touch the screen.";
        myLabel2.fontSize = 18;
		myLabel2.name = @"label";
        myLabel2.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame)+60);
        [self addChild:myLabel2];
		
        SKLabelNode *myLabel3 = [SKLabelNode labelNodeWithFontNamed:@"Chalkduster"];
        myLabel3.text = @"Try open the door of physics.";
        myLabel3.fontSize = 18;
		myLabel3.name = @"label";
        myLabel3.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame)+20);
        [self addChild:myLabel3];
    }
    return self;
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    /* Called when a touch begins */
	
	if(_touch==NO){
		_touch = YES;
		//ラベルを検索して物理体にする
		[self enumerateChildNodesWithName:@"label" usingBlock:^(SKNode *node, BOOL *stop) {
			node.physicsBody = [SKPhysicsBody bodyWithRectangleOfSize:node.frame.size];
			//ちょっと回す
			[node.physicsBody applyAngularImpulse:0.1];
		}];
	}
}

-(void)update:(CFTimeInterval)currentTime {
    /* Called before each frame is rendered */
}

-(void)didSimulatePhysics
{
	[self enumerateChildNodesWithName:@"label" usingBlock:^(SKNode *node, BOOL *stop) {
        if (node.position.y < -200){
            [node removeFromParent];
			
			// シーンを推移させる
			PhysicsScene* newScene  = [[PhysicsScene alloc] initWithSize:self.size];
			
			SKTransition *transition = [SKTransition doorsOpenHorizontalWithDuration:0.5];
			
			[self.view presentScene:newScene transition:transition];
		}
	}];
}

@end


