//
//  PhysicsScene.m
//  SpriteKitDemo2
//

#import "PhysicsScene.h"

@implementation PhysicsScene{
	
	SKTexture	*_textureRocket;
}

//シーンがビューに表示されたときに呼ばれる
- (void)didMoveToView:(SKView *)view
{
    self.backgroundColor = [SKColor blackColor];
    self.scaleMode = SKSceneScaleModeAspectFit;
	
	_textureRocket = [SKTexture textureWithImageNamed:@"Rocket"];
	
	SKLabelNode *myLabel1 = [SKLabelNode labelNodeWithFontNamed:@"Baskerville-Bold"];
	myLabel1.text = @"Wellcome, The Physics world!";
	myLabel1.fontSize = 20;
	myLabel1.fontColor = [UIColor colorWithRed:0.7 green:0.7 blue:0.7 alpha:1.0];
	myLabel1.name = @"label";
	myLabel1.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame)+80);
	[self addChild:myLabel1];
	
	SKLabelNode *myLabel2 = [SKLabelNode labelNodeWithFontNamed:@"Baskerville-Bold"];
	myLabel2.text = @"Please, touch,";
	myLabel2.fontSize = 16;
	myLabel2.fontColor = [UIColor colorWithRed:0.7 green:0.7 blue:0.7 alpha:1.0];
	myLabel2.name = @"label";
	myLabel2.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame)+40);
	[self addChild:myLabel2];
	
	SKLabelNode *myLabel3 = [SKLabelNode labelNodeWithFontNamed:@"Baskerville-Bold"];
	myLabel3.text = @"Left side or right side or center area.";
	myLabel3.fontSize = 16;
	myLabel3.fontColor = [UIColor colorWithRed:0.7 green:0.7 blue:0.7 alpha:1.0];
	myLabel3.name = @"label";
	myLabel3.position = CGPointMake(CGRectGetMidX(self.frame),CGRectGetMidY(self.frame));
	[self addChild:myLabel3];
	
	
	//フレームを物理アタリの境界線にする
	self.physicsBody = [SKPhysicsBody bodyWithEdgeLoopFromRect:self.frame];
	
	//self.physicsWorld.gravity = CGVectorMake(0, -(9.8/6));	//月面の重力にする
	//self.physicsWorld.speed = 0.5;							//物理シミュレーションの実行時間を1/2
}


-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    for (UITouch *touch in touches) {
		
		CGPoint location = [touch locationInNode:self];
		
		SKSpriteNode *sprite = [SKSpriteNode spriteNodeWithTexture:_textureRocket];
        sprite.position = location;
		sprite.name = @"Rocket";
        [self addChild:sprite];
		
		
        //スプライトをボリュームベースの物理体にする
		sprite.physicsBody = [SKPhysicsBody bodyWithCircleOfRadius:sprite.size.width/2];
		
		//sprite.physicsBody.dynamic = NO;				//物理シミュレーションの影響をうけるかどうか
		//sprite.physicsBody.affectedByGravity = NO;	//重力の影響を受けるかどうか
		//sprite.physicsBody.allowsRotation = NO;		//角度変化の影響を受けるかどうか
		//sprite.physicsBody.linearDamping = 1.0;		//空気抵抗(0.0 <--> 1.0)
		//sprite.physicsBody.angularDamping = 1.0;		//空気抵抗による回転速度の減退値(0.0 <--> 1.0)
		//sprite.physicsBody.restitution = 1.0;			//弾み具合(0.0 <--> 1.0)
		
		//-------------------------
		//物理体に力を加える
		//-------------------------
		CGFloat		radian = 0;
		//右側をタッチ
		if(location.x > 212 && location.x <= 320) {
			sprite.color = [UIColor redColor];
			sprite.colorBlendFactor = 0.5;
			// 角度
			radian = (M_PI/180) * 30;
			
			//sprite.physicsBody.mass *= 4;		//質量を増やす
			//sprite.physicsBody.density *= 4;	//密度を増やす
		}
		//左側をタッチ
		else if(location.x > 0 && location.x <= 106) {
			sprite.color = [UIColor blueColor];
			sprite.colorBlendFactor = 0.5;
			// 角度
			radian = (M_PI/180) * 330;
		}
		//中央をタッチ
		else{
			// 角度
			radian = (M_PI/180) * 0;
		}
		sprite.zRotation = radian;
		
		CGFloat	x = sin(radian);
		CGFloat	y = cos(radian);
		
		sprite.physicsBody.velocity = CGVectorMake(-(1500*x), (1500*y));	//ベクトル
		//[sprite.physicsBody applyImpulse:CGVectorMake(-(80*x), (80*y))];	//インパルス
		//[sprite.physicsBody applyForce:CGVectorMake(-(4000*x), (4000*y))];	//フォース
	}
}


@end
